/* Epidemic and extinction times of a density-dependent birth and death process */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double frand(void)
{
 return 1.0-(double)rand()/(RAND_MAX+1.0);
}
 
   /*------------- START THE MAIN PROGRAM ----------------*/

main(void)
{
	int	i,
		epidemic, /* number of samples epidemic occurs */
		extinct, /* number of samples extinction occurs */
		samples, /* number of repetition of simulations */
		initsize; /* initial size */
	long int	seed,
			totalsize, /* total population size */
			K, /* population size at each time */
			size; /* size at each time of the process */
	double	brate, /* birth rate */
		drate, /* death rate */
		/* timeobserved,  time to be simulated */
		t; /* present time */
	char	*file1 = "datax.dat",*file2 = "extinctx.dat",
		*file3 = "epidemicx.dat";
	FILE	*fp1,*fp2,*fp3;

   /*----------------- initial parameters -----------------*/

	printf(" Birth rate (any positive real number) = ");
	scanf("%lf",&brate);
	printf("\n");
	printf(" Death rate (any positive real number) = ");
	scanf("%lf",&drate);
	printf("\n");
	/* printf(" Time to be simulated (positive number<=1000) = ");
	scanf("%lf",&timeobserved);
	printf("\n"); */
	printf(" Initial size of the process (not so large positive integer) = ");
	scanf("%d",&initsize);
	printf("\n");
	printf(" Total population size(>initial size) = ");
	scanf("%d",&totalsize);
	printf("\n");
	printf(" Samples = ");
	scanf("%d",&samples);
	printf("\n");
	printf(" Random number seed (any integer) = ");
	scanf("%d",&seed);
	printf("\n\n");

  /* -------------------------------------------------------*/

	fp1=fopen(file1,"w");
	fprintf(fp1," << Epidemic and extinction time of a density-dependent birth and death process >>\n\n");
	fprintf(fp1," Birth rate =%3.3f\n\n",brate);
	fprintf(fp1," Death rate =%3.3f\n\n",drate);
	/* fprintf(fp1," Time to be simulated =%4.2f\n\n",timeobserved); */
	fprintf(fp1," Total population size = %d\n\n",totalsize);
	fprintf(fp1," Initial size of the process = %d\n\n",initsize);
	fprintf(fp1," Samples = %d\n\n",samples);
	fprintf(fp1," Random number seed = %d\n\n",seed);
	/* fclose(fp1); */

  /*--------------- start simulation ------------------*/

	fp2=fopen(file2,"w");fp3=fopen(file3,"w");
	srand(seed); /* giving the seed of rand */
	epidemic=0;extinct=0;
	for (i=1;i<=samples;++i) {
		size=initsize;t=0.0;K=totalsize;
		while ((K>size)&&(size!=0)) {
			t+=-log(frand())/((brate*(1.0-(double)size/(double)K)+drate)*(double)size);
			if (frand()<drate/(brate*(1.0-(double)size/(double)K)+drate)) {size--;K--;}
			else size++;
		}
		if (size==0) {++extinct;fprintf(fp2,"%5.3f\n",t);}
		else {++epidemic;fprintf(fp3,"%5.3f\n",t);}
	}
	fprintf(fp1," Extinction probability = %3.3f\n\n",(double)extinct/(double)samples);
	fprintf(fp1," Epidemic probability = %3.3f\n\n",(double)epidemic/(double)samples);
	fclose(fp1);fclose(fp2);fclose(fp3);
}
