
   /* ExtinctTimeLBD.c */
   /* Extinction time of a linear birth and death process */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double frand(void)
{
 return 1.0-(double)rand()/(RAND_MAX+1.0);
}

main(void)
{
 int i,
     samples, /* number of repetition of simulations */
     initsize; /* initial size */
 long int seed,
          level, /* a size to be exceeded by a B-D process */
          size; /* size at each time of the process */
 double brate, /* birth rate */
        drate, /* death rate */
        k, /* brate+drate */
        b, /* conditional birth probability */
        simtime, /* time to be simulated */
        t; /* present time */
 char *file1 = "datax.dat",*file2 = "extinctx.dat";
 FILE *fp1,*fp2;

   /*------------- Input initial parameters --------------*/

 printf(" Birth rate (any positive real number) = ");
 scanf("%lf",&brate);
 printf("\n");
 printf(" Death rate (any positive real number) = ");
 scanf("%lf",&drate);
 printf("\n");
 printf(" Time to be simulated (positive number<=1000) = ");
 scanf("%lf",&simtime);
 printf("\n");
 printf(" Initial size of the process (not so large positive integer) = ");
 scanf("%d",&initsize);
 printf("\n");
 printf(" Limited size for a birth and death process (large positive integer) = ");
 scanf("%d",&level);
 printf("\n");
 printf(" Samples = ");
 scanf("%d",&samples);
 printf("\n");
 printf(" Random number seed (any integer) = ");
 scanf("%d",&seed);
 printf("\n\n");


  /* ------- Print initial parametersin a file "datax.dat" -------*/

 fp1=fopen(file1,"w");
 fprintf(fp1,"   << Extinction time of linear birth and death process >>\n\n");
 fprintf(fp1," Birth rate =%3.3f\n\n",brate);
 fprintf(fp1," Death rate =%3.3f\n\n",drate);
 fprintf(fp1," Time to be simulated =%4.2f\n\n",simtime);
 fprintf(fp1," Initial size of the process = %d\n\n",initsize);
 fprintf(fp1," Limited size for a birth and death process = %d\n\n",level);
 fprintf(fp1," Samples = %d\n\n",samples);
 fprintf(fp1," Random number seed = %d\n",seed);
 fclose(fp1);

  /* Start simulation to save the results in a file "extinctx.dat" */

 fp2=fopen(file2,"w");
 k=brate+drate;b=brate/k;
 srand(seed); /* giving the seed of rand */
 for (i=1;i<=samples;++i) {
  size=initsize;t=0.0;
  while (t<simtime && size<level && size!=0) {
   t+=-log(frand())/(k*(double)size);
   if (frand()<b) ++size;else --size;
  }
  if (size==0) fprintf(fp2,"%5.3f\n",t);
 }

 fclose(fp2);
}
