
   /* LinBD.c */
   /* Linear birth and death process */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double frand(void)
{
 return 1.0-(double)rand()/(RAND_MAX+1.0);
}

main(void)
{
 long int seed,
          size; /* size at each time of the process */
 double	brate, /* birth rate */
        drate, /* death rate */
        k, /* brate+drate */
        b, /* conditional birth probability */
        simtime, /* time to be simulated */
        t; /* present time */
 char *file1 = "datax.dat",*file2 = "samplex.dat";
 FILE *fp1,*fp2;

   /*------------- Input initial parameters --------------*/

 printf(" Birth rate (any positive real number) = ");
 scanf("%lf",&brate);
 printf("\n");
 printf(" Death rate (any positive real number) = ");
 scanf("%lf",&drate);
 printf("\n");
 printf(" Time to be simulated (positive real number<=1000) = ");
 scanf("%lf",&simtime);
 printf("\n");
 printf(" Initial size of the process (not so large positive integer) = ");
 scanf("%d",&size);
 printf("\n");
 printf(" Random number seed (any integer) = ");
 scanf("%d",&seed);
 printf("\n\n");

  /* ------- Print initial parametersin a file "datax.dat" -------*/

 fp1=fopen(file1,"w");
 fprintf(fp1,"      << Linear birth and death process >>\n\n");
 fprintf(fp1," Birth rate =%3.3f\n\n",brate);
 fprintf(fp1," Death rate =%3.3f\n\n",drate);
 fprintf(fp1," Time to be simulated =%4.2f\n\n",simtime);
 fprintf(fp1," Initial size of the process = %d\n\n",size);
 fprintf(fp1," Random number seed = %d\n",seed);
 fclose(fp1);

  /* Start simulation to save the results in a file "samplex.dat" */

 fp2=fopen(file2,"w");
 fprintf(fp2,"%5.3f\t %10d\n",0.0,size);
 k=brate+drate;b=brate/k;
 srand(seed); /* giving the seed of rand */
 t=0.0;
 while (t<simtime && size!=0) {
  t+=-log(frand())/(k*(double)size);
  fprintf(fp2,"%5.3f\t %10d\n",t,size);
  if (frand()<b) ++size;else --size;
  fprintf(fp2,"%5.3f\t %10d\n",t,size);
 }
 fclose(fp2);
}
